Imports System.Runtime.InteropServices
Imports System.Threading

Public Class Form1

    Private remoteModules As New ArrayList()
    Private ADDON_TO_MYAPP_MessageId As IntPtr
    Private MSG_ADDON_TO_MYAPP As String = "ADDON_TO_MYAPP"

    <DllImport("user32.dll")> _
    Public Shared Function RegisterWindowMessage( _
        ByVal lpString As [String]) As IntPtr
    End Function

    Protected Overloads Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = CInt(ADDON_TO_MYAPP_MessageId) Then
            m.Result = CType(1, IntPtr)
            If m.WParam <> IntPtr.Zero Then
                Thread.Sleep(CInt(m.WParam))
            End If
            RefreshItems()
        End If
        MyBase.WndProc(m)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load

        Me.ADDON_TO_MYAPP_MessageId = _
            RegisterWindowMessage(MSG_ADDON_TO_MYAPP)
        RefreshItems()
    End Sub

    Private Sub buttonNavigate_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles buttonNavigate.Click

        Try
            If comboBox1.SelectedIndex > -1 Then
                Dim [module] As ADX_IE_Addon_And_WinApp_VB.IEModule = _
                    TryCast(remoteModules(comboBox1.SelectedIndex), _
                    ADX_IE_Addon_And_WinApp_VB.IEModule)

                [module].NavigateTo(textBox1.Text.Trim())
            End If
        Catch err As Exception
            MessageBox.Show(err.Message, Me.Text, _
                MessageBoxButtons.OK, MessageBoxIcon.[Error])

        End Try
    End Sub

    Private Sub RefreshItems()
        Dim [module] As ADX_IE_Addon_And_WinApp_VB.IEModule
        comboBox1.BeginUpdate()
        Try
            remoteModules.Clear()
            comboBox1.Items.Clear()
            Dim modules As ArrayList = _
                AddinExpress.IE.ADXIEModule.GetModulesByTypeName( _
                    "ADX_IE_Addon_And_WinApp_VB.IEModule")
            If modules.Count > 0 Then
                For i As Integer = 0 To modules.Count - 1
                    [module] = TryCast(modules(i), _
                        ADX_IE_Addon_And_WinApp_VB.IEModule)
                    If [module] IsNot Nothing Then
                        remoteModules.Add([module])
                        comboBox1.Items.Add( _
                            [module].GetCurrentTitle())
                    End If
                Next
            End If
            If comboBox1.Items.Count > 0 Then
                comboBox1.SelectedIndex = 0
            Else
                Application.[Exit]()
            End If
        Catch err As Exception
            MessageBox.Show(err.Message, Me.Text, _
                MessageBoxButtons.OK, MessageBoxIcon.[Error])
        Finally
            comboBox1.EndUpdate()
        End Try
    End Sub
End Class
